/*================== bmpdiv.c =============================================
! ணࠬ ᦠ  殮 8  BMP-䠩,
! 樨 뢮  ᪥.
!--------------------------------------------------------------------------
! FF1, FF2, A1, A2, A3, A4, AA, A, I, J, II, DF, TMP - ⨢
! NUM - ᫮ ८ࠧ
! HEDFI1, HEDFI2 - 
! IMI, IMO, IMT -  䠩
! BUFER1, BUFER2, BUFER3 - ⥩    䠩
! OPT -   ࠡ
!========================================================================*/

#include<string.h>
#include<stdlib.h>
#include<stdio.h>
#include<io.h>
#include<fcntl.h>
#include<conio.h>

typedef struct
{
      int  BM;
      long FZ;
      long U1;
      long HZ;
      long U2;
      long PX;
      long PY;
      int  U3;
      int  BP;
      long U4;
      long AP;
      char UP[16];
      char PL[1024];
}     BMPH;

unsigned char BUFER1[4096],BUFER2[4096],BUFER3[4096];
unsigned char OPT,IMI[80],IMO[80],IMT[80],TMP[80];
int FF1,FF2,NUM,II,I,J,A,A1,A2,A3,A4,AA;
long DF;
BMPH HEDFI1,HEDFI2;

void ZAST(void);
void DIVIS(void);

/*-----------------------------------------------------------------------*/
main(int argc, char *argv[])
{
    NUM=argc;if(NUM!=4) ZAST();
    strcpy(TMP,argv[1]);strcpy(IMI,argv[2]);strcpy(IMO,argv[3]);
    NUM=strlen(TMP);if(NUM!=2) ZAST();
    OPT=TMP[0];NUM=TMP[1]-48;
    if(OPT!='/' && OPT!='*') ZAST();
    if(NUM<1 || NUM>9) ZAST();
    if (IMI=="" || IMO=="") ZAST();
    A=strcspn(IMO,".bmp")-1;if(A<0) A=strlen(IMO);
    memcpy(IMT,IMO,A);strcat(IMT,".tmp");
    FF2=_creat(IMT,0);close(FF2);remove(IMT);
    for(II=1;II<=NUM;II++)
    {
        DIVIS();
        FF2=_creat(IMT,0);close(FF2);remove(IMT);
        rename(IMO,IMT);strcpy(IMI,IMT);
    }
    rename(IMT,IMO);
}
/*-----------------------------------------------------------------------*/
void ZAST(void)
{
    printf(" `BMPDIV.EXE`\n");
    printf(" (E.H.Hauser, Baku, 27/02/00, 03:00:00, size 26808)\n");
    printf(" usage: >bmpdiv.exe ?n sourcename.bmp targetname.bmp\n");
    printf(" char `?` is:\n");
    printf("       / -compression in 2 times (till 4 points)\n");
    printf("       * -stretching  in 2 times\n");
    printf(" n -number of transformations (1 to 9)\n");
    exit(0);
}
/*-----------------------------------------------------------------------*/
void DIVIS(void)
{
    FF1=open(IMI,O_RDWR|O_BINARY);
    DF=filelength(FF1); if(DF<1) goto DER;
    lseek(FF1,0,SEEK_SET);read(FF1,&HEDFI1,1078);HEDFI2=HEDFI1;
    if(HEDFI1.BP!=8) goto DER;
    if(HEDFI1.HZ!=1078) goto DER;
    if(OPT==47) {
       if(HEDFI1.PX>4096) goto PER;
       if ((HEDFI1.PX % 2)!=0 || (HEDFI1.PY % 2)!=0) goto PER;
       HEDFI2.PX=HEDFI1.PX/2;HEDFI2.PY=HEDFI1.PY/2;
      }
    else
      {
       if(HEDFI1.PX>2048) goto PER;
       HEDFI2.PX=HEDFI1.PX*2;HEDFI2.PY=HEDFI1.PY*2;
    }
    DF=HEDFI2.PX*HEDFI2.PY;HEDFI2.AP=DF;HEDFI2.FZ=DF+HEDFI2.HZ;
    FF2=_creat(IMO,0);close(FF2);
    FF2=open(IMO,O_RDWR|O_BINARY);write(FF2,&HEDFI2,1078);
    if(OPT==47) {
       for(J=0;J<HEDFI2.PY;J++) {
           lseek(FF1,1078+J*2*HEDFI1.PX,SEEK_SET);
           read(FF1,BUFER1,(unsigned)HEDFI1.PX);
           lseek(FF1,1078+(J*2+1)*HEDFI1.PX,SEEK_SET);
           read(FF1,BUFER2,(unsigned)HEDFI1.PX);
           for(I=0;I<HEDFI2.PX;I++) {
               A1=BUFER1[I*2];A2=BUFER1[I*2+1];
               A3=BUFER2[I*2];A4=BUFER2[I*2+1];
               A=A1+A2+A3+A4;AA=A % 4;A=A/4;
               if(AA>1) A=A+1;
               BUFER3[I]=A;
           }
           write(FF2,BUFER3,(unsigned)HEDFI2.PX);
           A=(int)((J+1)*100.0/HEDFI2.PY);
           AA=wherey();gotoxy(1,AA);printf("%i%s",A,"% ");
       }
      }
    else
      {
       for(J=0;J<HEDFI1.PY;J++) {
           lseek(FF1,1078+J*HEDFI1.PX,SEEK_SET);
           read(FF1,BUFER1,(unsigned)HEDFI1.PX);
           for(I=0;I<HEDFI1.PX;I++) {
               A=BUFER1[I];BUFER3[2*I]=A;BUFER3[2*I+1]=A;
           }
           write(FF2,BUFER3,(unsigned)HEDFI2.PX);
           write(FF2,BUFER3,(unsigned)HEDFI2.PX);
           A=(int)((J+1)*100.0/HEDFI1.PY);
           AA=wherey();gotoxy(1,AA);printf("%i%s",A,"% ");
       }
    }
    printf("\n");close(FF1);close(FF2);
    return;
DER: 
    printf("\n Data error in source file\n");
    exit(0);
PER:
    printf("\n The inadmissible size, transformation it is impossible\n");
    exit(0);
}
/*=======================================================================*/
