{================== bmpdiv.pas ============================================
! ணࠬ ᦠ  殮 8  BMP-䠩,
! 樨 뢮  ᪥.
!--------------------------------------------------------------------------
! FM1, FM2, FF1, FF2, A1, A2, A3, A4, AA, A, I, J, II, DF - ⨢
! NUM - ᫮ ८ࠧ
! HEDFI[] - 
! IMI, IMO, IMT -  䠩
! BUFER[] - ⥩    䠩
! OPT -   ࠡ
!=========================================================================}

program BMPDIV;

uses crt;

type BMPH=record
     BM: integer;
     FZ: longint;
     U1: longint;
     HZ: longint;
     U2: longint;
     PX: longint;
     PY: longint;
     U3: integer;
     BP: integer;
     U4: longint;
     AP: longint;
     U5: string[16];
     PL: array[1..1024] of byte;
end;

type
     TYPFB=file of byte;
     TYPBM=file of BMPH;

var
    NUM,II,I,J,A,A1,A2,A3,A4,AA :integer;
    DF :longint;
    OPT,IMI,IMO,IMT :string;
    FF1,FF2 :TYPFB;
    FM1,FM2 :TYPBM;
    HEDFI :array[1..2] of BMPH;
    BUFER :array[1..3,1..2048] of byte;

{-------------------------------------------------------------------------}
procedure ZAST;
begin
    writeln(' `BMPDIV.EXE`');
    writeln(' (E.H.Hauser, Baku, 27/02/00, 03:00:00, size 10896)');
    writeln(' usage: >bmpdiv.exe ?n sourcename.bmp targetname.bmp');
    writeln(' char `?` is:');
    writeln('       / -compression in 2 times (till 4 points)');
    writeln('       * -stretching  in 2 times');
    writeln(' n -number of transformations (1 to 9)');
    halt;
end;
{-------------------------------------------------------------------------}
procedure DIVIS;
label DER,PER;
begin
    assign(FM1,IMI); reset(FM1);
    DF:=filesize(FM1); if DF<1 then goto DER;
    seek(FM1,0); read(FM1,HEDFI[1]); HEDFI[2]:=HEDFI[1];
    if HEDFI[1].BP<>8 then goto DER;
    if HEDFI[1].HZ<>1078 then goto DER;
    if OPT='/' then begin
       if (HEDFI[1].PX mod 2 <> 0) or (HEDFI[1].PY mod 2 <> 0) then goto PER;
       HEDFI[2].PX:=HEDFI[1].PX div 2; HEDFI[2].PY:=HEDFI[1].PY div 2;
    end else begin
       if HEDFI[1].PX>1024 then goto PER;
       HEDFI[2].PX:=HEDFI[1].PX*2; HEDFI[2].PY:=HEDFI[1].PY*2;
    end;
    DF:=HEDFI[2].PX*HEDFI[2].PY; HEDFI[2].AP:=DF;
    HEDFI[2].FZ:=DF+HEDFI[2].HZ;
    assign(FM2,IMO); rewrite(FM2); write(FM2,HEDFI[2]); close(FM2); erase(FM2);
    assign(FM2,IMO); rewrite(FM2); write(FM2,HEDFI[2]); close(FM1); close(FM2);
    assign(FF1,IMI); reset(FF1);
    assign(FF2,IMO); reset(FF2); seek(FF2,1078);
    if OPT='/' then begin
       for J:= 0 to HEDFI[2].PY-1 do begin
           seek(FF1,1078+J*2*HEDFI[1].PX);
           for I:=1 to HEDFI[1].PX do  read(FF1,BUFER[1,I]);
           seek(FF1,1078+(J*2+1)*HEDFI[1].PX);
           for I:=1 to HEDFI[1].PX do  read(FF1,BUFER[2,I]);
           for I:=1 to HEDFI[2].PX do begin
               A1:=BUFER[1,I*2-1]; A2:=BUFER[1,I*2];
               A3:=BUFER[2,I*2-1]; A4:=BUFER[2,I*2];
               A:=A1+A2+A3+A4; AA:=A mod 4; A:=A div 4;
               if AA>1 then A:=A+1;
               BUFER[3,I]:=A;
           end;
           for I:=1 to HEDFI[2].PX do  write(FF2,BUFER[3,I]);
           A:=round((J+1)*100.0/HEDFI[2].PY);
           gotoxy(1,whereY); write(A,'%');
       end;
    end else begin
       for J:=0 to HEDFI[1].PY-1 do begin
           seek(FF1,1078+J*HEDFI[1].PX);
           for I:=1 to HEDFI[1].PX do  read(FF1,BUFER[1,I]);
           for I:=1 TO HEDFI[1].PX do begin
               A:=BUFER[1,I]; BUFER[3,2*I-1]:=A; BUFER[3,2*I]:=A;
           end;
           for I:=1 to HEDFI[2].PX do  write(FF2,BUFER[3,I]);
           for I:=1 to HEDFI[2].PX do  write(FF2,BUFER[3,I]);
           A:=round((J+1)*100.0/HEDFI[1].PY);
           gotoxy(1,whereY); write(A,'%');
       end;
    end;
    writeln; close(FF1); close(FF2); exit;
DER:
    writeln('Data error in source file');
    halt;
PER:
    writeln('The inadmissible size, transformation it is impossible');
    halt;
end;
{-------------------------------------------------------------------------}
begin
    NUM:=paramcount; if NUM<>3 then ZAST;
    OPT:=paramstr(1); IMI:=paramstr(2); IMO:=paramstr(3);
    NUM:=length(OPT); if NUM<>2 then ZAST;
    A:=10; val(copy(OPT,2,1),NUM,A); OPT:=copy(OPT,1,1);
    A:=pos('.',IMO)-1; if A<0 then A:=length(IMO);
    IMT:=copy(IMO,1,A)+'.tmp';
    if (OPT<>'/') and (OPT<>'*') then ZAST;
    if (NUM<1) or (NUM>9) then ZAST;
    if (IMI='') or (IMO='') then ZAST;
    assign(FM2,IMT);
    rewrite(FM2);
    write(FM2,HEDFI[2]); close(FM2); erase(FM2);
    for II:=1 to NUM do begin
        DIVIS;
        assign(FM2,IMT); rewrite(FM2); write(FM2,HEDFI[2]);
        close(FM2); erase(FM2);
        assign(FF1,IMO); rename(FF1,IMT); IMI:=IMT;
    end;
    assign(FF1,IMT); rename(FF1,IMO);
end.
{=========================================================================}
